(*
 * This module defines abstract assembly code.  For control
 * and dataflow analysis, we only need to know the defs/uses,
 * the move-related nodes, and the outgoing edges in a node.
 *
 * ----------------------------------------------------------------
 *
 * Copyright (C) 1999 Jason Hickey, Caltech
 * Copyright (C) 2002,2001 Justin David Smith, Caltech
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Author: Jason Hickey
 * jyh@cs.caltech.edu
 *)
open Format

open Symbol

module type CodegenSig =
sig
   (*
    * prog is the type of an entire assembly program.
    *)
   type prog

   (*
    * compile_mir_of_fir fir -- build MIR code from the provided
    *    FIR mprog.  The mprog is generated by fir_mprog.ml and is
    *    a migration-safe version of the FIR.  Final typechecks
    *    and FIR safety checks are performed by this function.
    *
    * compile_asm_of_fir mir migrate -- build assembly code from
    *    the provided MIR code.  At this point, if the program is
    *    being migrated from another location, the migration data
    *    required to reconstruct the program must be provided.
    *    For new programs, migrate is None.
    *
    * compile_asm_of_fir fir migrate -- shorthand for composing
    *    the above two functions.
    *)
   val compile_mir_of_fir : Fir.mprog -> Mir.prog
   val compile_asm_of_mir : Mir.prog -> Frame_type.migrate option -> prog
   val compile_asm_of_fir : Fir.mprog -> Frame_type.migrate option -> prog

   (*
    * print_prog out prog -- print an assembly program to the
    *    indicated output channel.
    *
    * print_object filename prog -- print an object file to the
    *    file indicated.
    *
    * link_object out_filename in_filenames -- link the indicated
    *    input objects to a final object named in out_filename.
    *)
   val print_prog : formatter -> prog -> unit
   val print_object : string -> prog -> unit
   val link_object : string -> string list -> unit

   (*
    * catch -- attempt to run a function, and catch backend
    *    exceptions thrown by the function.  The program will
    *    abort if a backend exception is caught.
    *)
   val catch : ('a -> 'b) -> 'a -> 'b
end


(*
 * -*-
 * Local Variables:
 * Caml-master: "compile"
 * End:
 * -*-
 *)
